div_signed_16_bits MACRO
;***  Paramtres : \1 dnominateur en word
;                  \2 numrateur en word
;                  \3 distinctif de label
;                    en sortie : \2:=\2 / \1 en word !
 tst.w  \2
 bpl    numerateur_positif_\3
 neg.w  \2
 neg.w  \1
numerateur_positif_\3:
 divs \1,\2
 ENDM

div_real_signed_16_bits MACRO
;***  Paramtres : \1 dplacement pour le floating point
;                  \2 dnominateur en word
;                  \3 numrateur en word
;                  \4 distinctif de label
;                    en sortie : \2:=\2 / \1 en word !
 tst.w  \3
 bpl    numerateur_positif_\4
 neg.w  \3
 neg.w  \2
numerateur_positif_\4:
 asl.l  #\1,\3
 divs \2,\3
 ENDM

div_signed_32_bits MACRO
;***  Paramtres : \1 dnominateur en word
;                  \2 numrateur en word
;                  \3 distinctif de label
;                    en sortie : \2:=\2 / \1 en word ! tendu en long word pour le signe

 tst.w  \2
 bpl    numerateur_positif_\3
 neg.w  \2
 neg.w  \1
numerateur_positif_\3:

 divs \1,\2

 andi.l #$FFFF,\2                 ;on vire le reste de la division
                                  ;est-ce que le word est ngatif
 tst.w  \2
 bpl poids_fort_positif_\3
 ori.l  #$FFFF0000,\2             ;oui alors le long word aussi :
;                                  on comble le poids fort avec des 1111---11
poids_fort_positif_\3:

 ENDM

div_real_signed_32_bits MACRO
;***  Paramtres : \1 dnominateur en word
;                  \2 numrateur en word
;                  \3 distinctif de label
;                    en sortie : \2:=\2 / \1 en word ! tendu en long word pour le signe

 tst.w  \2
 bpl    numerateur_positif_\3
 neg.w  \2
 neg.w  \1
numerateur_positif_\3:
 asl.l #7,\2                      ;passe en floating point (nbre rel)

 divs \1,\2

 andi.l #$FFFF,\2                 ;on vire le reste de la division
                                  ;est-ce que le word est ngatif
 tst.w  \2
 bpl poids_fort_positif_\3
 ori.l  #$FFFF0000,\2             ;oui alors le long word aussi :
;                                  on comble le poids fort avec des 1111---11
poids_fort_positif_\3:

 ENDM

print_hex MACRO

 movem.l d0-d2/d4,-(A7)   ;n'altre pas les registres

 move.l \1,d0
 move.l #\2,d1
 move.l #\3,d2
 move.l #7,d4
 jsr hexlib::put_hex

 movem.l (A7)+,d0-d2/d4   ;car leur valeur est restaure  la fin

 ENDM

break MACRO
 move.l d0,-(A7)
; Attend l'appuie d'une touche
 jsr flib::idle_loop
;Touche Esc ?
 cmpi.w #0264,d0
 bne touche_echap_relachee_\1
 move.l (A7)+,d0
 rts                         ;Esc=Fin du programe
touche_echap_relachee_\1:
 move.l (A7)+,d0
  ENDM

cree_un_bloc_memoire_de_taille MACRO
;***  Paramtres :
;                   \1 mmoire  allouer (en long word)
;                       rcuprer le n de handle dans d0 en sortie
;                       utiliser la fonction TIOS::DEREF d0,<addresse>
;                               [pour que adresse pointe sur le handle.
;                   \2 pour diffrencier les labels

  MOVE.l  \1,-(A7)                ; empile la taille du bloc mmoire
  JSR     tios::HeapAlloc         ; appelle la fonction, D0 contient l'handle
  LEA     4(A7),A7                ; restaure la pile de 2

  tst.l d0
  bne quantite_de_memoire_ok_\2   ;pas assez de mmoire

;***  oui

  MOVE.w  #4,-(A7)        ; empile la couleur
  PEA     pas_assez_de_memoire(PC)
                          ; empile le pointeur de la chane de caractre
  MOVE.w  #0,-(A7)        ; empile l'ordonne
  MOVE.w  #0,-(A7)        ; empile l'abscisse
  JSR     tios::DrawStrXY ; appelle la fonction
  LEA     10(A7),A7       ; restaure la pile de 2+4+2+2=10

 break pas_assez_de_memoire_\2

 rts                      ;fin du programme

;***  non
quantite_de_memoire_ok_\2:

 ENDM

pas_assez_de_memoire: dc.b "Not enough memory !",0

supprime_le_handle_memoire MACRO
;***  Paramtre :
;                 \1.w nom du bloc mmoire  supprim au format word

 MOVE.w  \1,-(A7)             ; empile l'handle du bloc mmoire
 JSR     tios::HeapFree           ; appelle la fonction
 LEA     2(A7),A7                 ; restaure la pile de 2
 ENDM
