fmuls  macro   ;Division par 2^14 aprs une multiplication...
       muls \1,\2
       asr.l #7,\2           ;asr: on divise par 2^(\2) un nombre SIGNE
       endm

fdiv MACRO
;***  Paramtres : \1 dnominateur en word
;                  \2 numrateur en long word
;                  \3 distinctif de label
;                    en sortie : \2:=\2 / \1 en word ! tendu en long word pour le signe

; bpl    numerateur_positif_\3
; neg.l  \2
; neg.w  \1
;numerateur_positif_\3:
 divs \1,\2

 andi.l #$FFFF,\2                 ;on vire le reste de la division
                                  ;est-ce que le word est ngatif
 tst.w  \2
 bpl    le_poids_fort__n_est_pas_negatif_\3
 ori.l  #$FFFF0000,\2             ;oui alors le long word aussi :
;                                  on comble le poids fort avec des 1111---11
le_poids_fort_n_est_pas_negatif_\3:

 ENDM

;********************************************************************************************
;********************************************************************************************
;********************************************************************************************
;********************************************************************************************
init_nx MACRO
;********************************************************************************************
;Calculs de pointeurs a partir de rx,ry,rz:
;********************************************************************************************

   lea sinus,a3    ;a3:=addr(sinus)

   move.l rx,d0
   andi.l #127,d0  ;modulo 128
   asl.l  #1,d0
   add.l a3,d0
   move.l d0,a0         ;cosx:=addr(sinus)+2*rx
                        ;Voila pour x

   move.l ry,d0
   andi.l #127,d0
   lsl.l  #1,d0
   add.l a3,d0
   MOVE.l d0,a1      ;pareil pour y

   move.l rz,d0
   andi.l #127,d0
   lsl.l  #1,d0
   add.l a3,d0
   MOVE.l d0,a2    ;et pour z

;******************************************************************************************
;*************************************   Calcul des nx:   *********************************
;******************************************************************************************

   moveq.l #0,d2
   moveq.l #0,d3
   moveq.l #0,d4
   moveq.l #0,d5
   moveq.l #0,d6
   moveq.l #0,d7

   move.w 64(a0),d2       ;d2<=>cos(x)
   move.w 64(a1),d3       ;d3<=>cos(y)
   move.w 64(a2),d4       ;d4<=>cos(z)
   move.w (a0),d5         ;d5<=>sin(x)
   move.w (a1),d6         ;d6<=>sin(y)
   move.w (a2),d7         ;d7<=>sin(z)

   move.l d3,d0
   fmuls d4,d0
   move.w d0,nxx       ;nxx:=cos(ry)*cos(rz)

   move.l d2,d1
   fmuls d7,d1
;   neg.l d1

   move.l d5,d0
   fmuls d6,d0
   fmuls d4,d0

   sub.l d1,d0
   move.w d0,nxy       ;nxy:=sin(rx)*sin(ry)*cos(rz)-cos(rx)*sin(rz)

   move.l d5,d0
   fmuls d7,d0

   move.l d2,d1
   fmuls d6,d1
   fmuls d4,d1

   add.l d0,d1
   move.w d1,nxz        ;nxz:=sin(x)*sin(z)+cos(x)*sin(y)*cos(z)

   move.l d3,d0
   fmuls d7,d0
   move.w d0,nyx       ;nyx:=cos(x)*cos(z)

   move.l d5,d0
   fmuls d6,d0
   fmuls d7,d0

   move.l d2,d1
   fmuls d4,d1

   add.l d1,d0
   move.w d0,nyy        ;nyy:=sin(x)*sin(y)*cos(z)+cos(x)*sin(z)

   move.l d4,d0
   fmuls d5,d0
;   neg.l d0

   move.l d2,d1
   fmuls d6,d1
   fmuls d7,d1

   sub.l d0,d1
   move.w d1,nyz         ;nyz:=cos(x)*sin(y)*sin(z)-sin(x)*cos(z)

   move.w d6,nzx
   neg.w nzx             ;nzx:=-sin(y)

   move.l d5,d0
   fmuls d3,d0
   move.w d0,nzy          ;nzy:=sin(x)*cos(y)

   move.l d2,d0
   fmuls d3,d0
   move.w d0,nzz          ;nzz:=cos(x)*cos(y)

   ENDM

;********************************************************************************************
;********************************************************************************************
;********************************************************************************************
;********************************************************************************************
projection_plane MACRO
;********************************************************************************************
;*************************   Transformation 3D->2D   ****************************************
;********************************************************************************************

   move.l adresse_du_handle,a1   ;a1:=addr(bloc memoire contenant les coordonnes 2D)

   move.l len_pts,d7
   lea pts,a0

rotate:

 move.l (a0)+,d4                  ;charge d4 <=> x
 move.l (a0)+,d5                  ;       d5 <=> y
 move.l (a0)+,d6                  ;       d6 <=> z

;Calcul de la coordonne sur z
 move.l d4,d1
 muls   nzx,d1
 move.l d5,d2
 muls   nzy,d2
 move.l d6,d3
 muls   nzz,d3
 add.l  d1,d3
 add.l  d2,d3                     ;d3:=x*nzx+y*nzy+z*nzz

 muls sz,d3

 asr.l #8,d3
 asr.l #8,d3                      ;On adapte l'ordre de grandeur

;calcul de l'angle de fuite
 sub.w l,d3
 neg.w d3                         ;d3:= z - un peu plus que 128 (au cas o ca dborderait)

;***  projection plane sur l'axe x
 move.l d4,d1
 muls   nxx,d1
 move.l d5,d2
 muls   nxy,d2
 add.l  d2,d1
 move.l d6,d2
 muls   nxz,d2
 add.l  d2,d1                     ;d1:=x*nxx+y*nxy+z*nxz

;***  Rapport de rduction (pour s'adapter  la taille de l'cran)
 muls sx,d1
 asr.l #8,d1

;***  gestion de la perspective
;     x' := (l/(l-z))*x o l=2^14 est la distance oeil cran
 divs d3,d1
 andi.l #$FFFF,d1                 ;on vire le reste de la division

;***  Dplacement  l'cran :
 add.w tx,d1

;***  On mmorise la valeur:
 move.w d1,(a1)+

;*** Pareil pour y :
 move.l d4,d1
 muls   nyx,d1
 move.l d5,d2
 muls   nyy,d2
 add.l  d2,d1
 move.l d6,d2
 muls   nyz,d2
 add.l  d2,d1

 muls sy,d1
 asr.l #8,d1

 divs d3,d1
 andi.l #$FFFF,d1

 neg.w d1
 add.w ty,d1
 move.w d1,(a1)+
                                  ;d1:=x*nyx+y*nyy+z*nyz
 DBra d7,rotate

 ENDM

;Include la table des sinus prcalculs:
sinus: dc.w 0,6,13,19,25,31,37,43,49,55,60,66,71,76,81,86,91,95,99,103,106,110,113,116,118,121,
       dc.w 122,124,126,127,127,128,128,128,127,127,126,124,122,121,118,116,113,110,106,103,99,
       dc.w 95,91,86,81,76,71,66,60,55,49,43,37,31,25,19,13,6,0,-6,-13,-19,-25,-31,-37,-43,-49,
       dc.w -55,-60,-66,-71,-76,-81,-86,-91,-95,-99,-103,-106,-110,-113,-116,-118,-121,-122,-124,
       dc.w -126,-127,-127,-128,-128,-128,-127,-127,-126,-124,-122,-121,-118,-116,-113,-110,-106,
       dc.w -103,-99,-95,-91,-86,-81,-76,-71,-66,-60,-55,-49,-43,-37,-31,-25,-19,-13,-6,0,6,13,
       dc.w 19,25,31,37,43,49,55,60,66,71,76,81,86,91,95,99,103,106,110,113,116,118,121,122,124,
       dc.w 126,127,127,128,128,128

;Rotations:
rx dc.l 0
ry dc.l 0
rz dc.l 0
;Homottie
sx: dc.w 256
sy: dc.w 256
sz: dc.w 256
;Dplacements  l'cran :
tx: dc.w 80
ty: dc.w 50

;Formules de changement de repre:
;x=x'*nxx+y'*nxy+z'*nxz
;y=x'*nyx+y'*nyy+z'*nyz
;z=x'*nzx+y'*nzy+z'*nzz

nxx dc.w 0
nxy dc.w 0
nxz dc.w 0
nyx dc.w 0
nyy dc.w 0
nyz dc.w 0
nzx dc.w 0
nzy dc.w 0
nzz dc.w 0

l:  dc.w 32    ;distance de l'oeil de l'cran
