;***  Cherche le point suivant sur la ligne gauche
point_suivant_gauche MACRO
 cmp.l coord_max,a2
 beq psd_retour\1
 lea 4(a2),a2                 ;a2 pointe sur le point gauche suivant
 jmp psd_fin\1
psd_retour\1:
 move.l coord_min,a2
psd_fin\1:
 ENDM

;***  Cherche le point suivant sur la ligne droite
point_suivant_droit MACRO
 cmp.l coord_min,a3
 beq psg_retour\1              ;A-t-on atteint l'extrmit du tableau polygone ?
 lea -4(a3),a3                 ;a2 pointe sur le point gauche suivant
 jmp psg_fin\1
psg_retour\1:
 move.l coord_max,a3
psg_fin\1:
 ENDM

;*************************************************************************************
;*************   Calcul de l'incrment de ligne :   **********************************
;*************************************************************************************

increment_ligne_gauche MACRO
 move.w 2(a2),d0
 cmp.w yi,d0
 bne no_update_inc_y_gauche
suivant_gauche:
 movea.l a2,a4                  ;a4 pointe sur l'ancien point (sauvegarde de a2)

 point_suivant_gauche           ;a2 pointe sur le nouveau

 move.w 2(a4),d1
 sub.w  2(a2),d1		;d1:= Delta_y (nbre d'itrations)
 beq suivant_gauche             ;la diviviseur=0 alors on prend le pt suivant

 move.w (a4),d0
 asl.w #7,d0
 move.w d0,pos_gauche           ;pos_droit=coordonne x de dpart de ligne.

 move.w  d1,d2              ;prserve d2 (pour usage ultrieur)

 moveq.l #0,d0
 move.w (a4),d0
 sub.w  (a2),d0

;***  Division :
 div_real_signed_16_bits 7,d1,d0,nng

 move.w d0,inc_gauche

;***  Pareil pour la texture :

;**   On garde les valeurs de dpart de la texture:
 moveq.l #0,d0
 move.w 0(a4,a6),d0
 asl.l #8,d0
 move.l d0,texture_pos_gauche_x

 move.w 2(a4,a6),d0
 asl.l #8,d0
 move.l d0,texture_pos_gauche_y

;***   Puis on calcule l'incrment:
 move.w d2,d1

;***  d1 contient le nbre d'itrations
 moveq.l #0,d0
 move.w 0(a4,a6),d0
 sub.w  0(a2,a6),d0

 div_real_signed_16_bits 8,d1,d0,texture_inc_gauche_x
 ext.l d0

 move.l d0,texture_inc_gauche_x     ;d0 contient la prmire partie de inc_texture

;***  d2 contient toujours le nbre d'itrations
 moveq.l #0,d1
 move.w 2(a4,a6),d1
 sub.w  2(a2,a6),d1

 div_real_signed_16_bits 8,d2,d1,texture_inc_gauche_y
 ext.l d1

 move.l d1,texture_inc_gauche_y

no_update_inc_y_gauche:

 ENDM

increment_ligne_droit MACRO
 move.w 2(a3),d0
 cmp.w yi,d0
 bne no_update_inc_y_droit
suivant_droit:
 movea.l a3,a5              ;a4 pointe sur l'ancien point (sauvegarde de a2)

 point_suivant_droit           ;a2 pointe sur le nouveau

 move.w 2(a5),d1
 sub.w  2(a3),d1            ;d1:= Delta_y (nbre d'itrations)
 beq suivant_droit             ;la diviviseur=0 alors on prend le pt suivant

 move.w (a5),d0
 asl.w #7,d0
 move.w d0,pos_droit           ;pos_droit=coordonne x de dpart de ligne.

 move.w  d1,d2              ;prserve d2 (pour usage ultrieur)

 moveq.l #0,d0
 move.w (a5),d0
 sub.w  (a3),d0

;***  Division :
 div_real_signed_16_bits 7,d1,d0,nnd
 move.w d0,inc_droit

;***  Pareil pour la texture :
;***  Plus besoin, ne sert plus !

;**   On garde les valeurs de dpart de la texture:
; moveq.l #0,d0
; move.w 0(a5,a6),d0
; asl.l #7,d0
; move.l d0,texture_pos_droit_x

; move.w 2(a5,a6),d0
; asl.l #7,d0
; move.l d0,texture_pos_droit_y

;***   Puis on calcule l'incrment:
; move.w d2,d1

;***  d1 contient le nbre d'itrations
; moveq.l #0,d0
; move.w 0(a5,a6),d0
; sub.w  0(a3,a6),d0

; div_real_signed_32_bits d1,d0,texture_inc_droit_x

; move.l d0,texture_inc_droit_x     ;d0 contient la prmire partie de inc_texture

;***  d2 contient toujours le nbre d'itrations
; moveq.l #0,d1
; move.w 2(a5,a6),d1
; sub.w  2(a3,a6),d1

; div_real_signed_32_bits d2,d1,texture_inc_droit_y

; move.l d1,texture_inc_droit_y

no_update_inc_y_droit:

 ENDM



;*******************************************************************************************
;*******************************************************************************************
;***********************   MAPPING  :   ****************************************************
;*******************************************************************************************
;*******************************************************************************************
mapping MACRO
;***  Ces rsultats vont souvent servir :
 moveq.l #0,d2
 moveq.l #0,d3
 moveq.l #0,d4
 moveq.l #0,d5

 move.w 2(a2),d4
 sub.w  2(a4),d4               ;d4 : hauteur de la ligne gauche

 move.w 2(a3),d5
 sub.w  2(a4),d5               ;d5 : hauteur de la ligne droite

; print_hex d4,0,0
; print_hex d5,1,0
; break jhgjhgjhgh

; 3 cas se distinguent
 cmp.w  d4,d5
 beq    pas_de_ligne_coupee
 bgt    ligne_droite_coupee

;*******************************************************************************************
;                *******************************************************
;                                       **************
;                                              *
;Si d5<d4 : on prend toute la ligne de gauche
;                       celle de droite est coupe
ligne_gauche_coupee:
;***  d5 : rapports de rduction

 asl.l	#8,d5
 divu	d4,d5
 andi.l #$FFFF,d5

;***   Ligne de gauche = ligne de rfrence

;***   Calcul de map_pos_droit_x (d2)
 move.w	0(a3,a6),d2
 sub.w	0(a4,a6),d2
 asl.w	#8,d2
 move.w	0(a2,a6),d0
 sub.w	0(a4,a6),d0             ;d0:= mx_droit_1 - mx_droit_2
 muls	d5,d0
 sub.w  d0,d2

;***   Calcul de map_pos_droit_y (d3)
 move.w	2(a3,a6),d3
 sub.w	2(a4,a6),d3
 asl.w	#8,d3
 move.w	2(a2,a6),d0
 sub.w	2(a4,a6),d0             ;d0:= mx_droit_1 - mx_droit_2
 muls	d5,d0
 sub.w  d0,d3

;***   Calcul de delta_x
 moveq.l #0,d1
 move.w	(a2),d1
 sub.w	(a4),d1
 muls	d5,d1
 asr.w	#8,d1
 add.w	(a4),d1
 sub.w	(a3),d1
 neg.w	d1

 jmp common

;*******************************************************************************************
;                *******************************************************
;                                       **************
;                                              *
;Si d4 < d5 : on prend toute la ligne de gauche; celle de droite est coupe
ligne_droite_coupee:

;***  d4 : rapports de rduction
 asl.l	#8,d4
 divu	d5,d4

; print_hex d4,10,10

;***   Ligne de droite = ligne de rfrence

;***   Calcul de map_pos_droit_x (d2)
 move.w	0(a3,a6),d2
 sub.w	0(a4,a6),d2             ;d0:= mx_droit_1 - mx_droit_2
 muls	d4,d2

 move.w	0(a4,a6),d0
 sub.w	0(a2,a6),d0
 asl.w	#8,d0
 add.w	d0,d2

;***   Calcul de map_pos_droit_y (d3)
 move.w	2(a3,a6),d3
 sub.w	2(a4,a6),d3             ;d0:= mx_droit_1 - mx_droit_2
 muls	d4,d3

 move.w	2(a4,a6),d0
 sub.w	2(a2,a6),d0
 asl.w	#8,d0
 add.w	d0,d3

;***   Calcul de delta_x
 move.w	(a3),d1
 sub.w	(a4),d1
 muls	d4,d1
 asr.w	#8,d1
 add.w	(a4),d1
 sub.w	(a2),d1

 jmp common

;*******************************************************************************************
;                *******************************************************
;                                       **************
;                                              *
pas_de_ligne_coupee:
;*** Cas le plus simple :
 move.w 0(a3,a6),d2
 sub.w  0(a2,a6),d2
 asl.l #8,d2
 move.w 2(a3,a6),d3
 sub.w  2(a2,a6),d3
 asl.l #8,d3

 move.w (a3),d1
 sub.w  (a2),d1
;*******************************************************************************************
;                *******************************************************
;                                       **************
;                                              *
;Calcul commun aux 3 cas :
common:
;***  Correspondance des registres :
;                              d1 delta_x
;                              d2 delta_mapping_sur_x de la texture
;                              d3 delta_mapping_sur_y de la texture

;***  On calcule l'increment principal
;    ! (suppos le mme dans tout le polygone pour optimiser grandement) !
;                       (Il vient de la le miracle !)

; print_hex d1,10,0
;***  Si d1 <= 0 jmp fin_du_tarce (du polygone) (label dans tpoly.asm)
 tst.w d1
 bmi fin_du_tracage
 beq fin_du_tracage

 move.w d1,-(A7)                ;prserve d1
 andi.l #$FFFF,d2
 div_signed_16_bits d1,d2,incpx
 move.w (a7)+,d1                ;restaure d1
 ext.l	d2
 move.l d2,increment_principal_x

 move.w d1,-(A7)                ;prserve d1
 andi.l #$FFFF,d3
 div_signed_16_bits d1,d3,incpy
 move.w (a7)+,d1                ;restaure d1
 ext.l	d3
 move.l d3,increment_principal_y

; print_hex d2,0,10
; print_hex d3,1,10

 move.b d2,special_add1
 moveq.w #0,d1
 move.b d3,d1
 ror.l	#8,d1

 asr.w #8,d2
 asr.w #8,d3
 muls  #largeur_de_l_image,d3
 add.w d2,d3
 move.w d3,d0
 ext.l d0
 andi.l #$00FFFFFF,d0
 or.l  d1,d0

 move.l d0,special_add2

; print_hex special_add1,0,0
; print_hex special_add2,1,0
; break kjh

 ENDM

convert_to_a_special_format MACRO
;****   Entres :
;                   - %1.w abscisse (Hi byte: patie entiere; Low byte:partie (dcimale)
;                   - %2.w ordonnes (itou)
;****   Sorties :
;                   - %3.b parties dcimales des abscisses
;                   - %4.l le Hi byte du Hi Word contient la partie decimale des ordonnes




 ENDM